'****************************************************************************
'
' UKAW Paket   : GR-SORT (Newsgroup Sort-Utility for UKAW *.gr files
' Version      : 1.27g
' Compilation  : Thomas Gohel (gohel@basicguru.com)
' Last Files at: www.snafu.de/~pbsound/CrossPoint
'            or: www.basicguru.com/pbsound-hq/pbsources.win
' Last Updates : see directly in the sources
'
' all original sources by Thomas Gohel
'
'****************************************************************************

DEFLNG A-Z

$RESOURCE "UKAW.PBR"
$INCLUDE "WIN32API.INC"
$INCLUDE "UKAW.INC"
$INCLUDE "UKAWLOG.BAS"

DECLARE SUB Get_NewsgroupList(Filemaske AS STRING)
DECLARE SUB Check_NewsgroupList(Filename AS STRING)
DECLARE SUB Sort_NewsgroupList(Filename AS STRING)

FUNCTION PbMain() AS LONG

	$INCLUDE "UKAW.VER"
        sLogApp = "GR-SORT"

        IF COMMAND$ = "" OR INSTR(COMMAND$,"?") > 0 THEN
            STDOUT "GR-SORT " + Version$ + "                              (Freeware sources by Thomas Gohel)"
            STDOUT "                                                   compilation by " + Author$
            STDOUT " "
            STDOUT "Usage: gr-sort <news.gr>  sort specific newsgroup file"
            STDOUT "   or:         <*.gr>     sort all newsgroup '*.gr'-files" 
            STDOUT "   or:         <*.*>      sort all newsgroup files, with auto detect"
            EXIT FUNCTION
        END IF

        LogOpen
        Get_NewsgroupList(COMMAND$)
        LogClose

END FUNCTION

SUB Get_NewsgroupList(Filemaske AS STRING)
        Filename$ = DIR$(Filemaske$)
        IF Filename$ <> "" THEN
            DO
                Check_NewsgroupList(Filename$)
                Filename$ = DIR$
            LOOP UNTIL Filename$ = ""
        ELSE
            LogWrite "File: " + Filemaske$ + " not found!", -1, %LogState_OtherError
        END IF
END SUB

SUB Check_NewsgroupList(Filename AS STRING)
        hGRFile = FREEFILE
        OPEN Filename$ FOR BINARY AS #hGRFile
            GET$ #hGRFile, 12, Test$
        CLOSE hGRFile
        IF Test$ = "!new_groups:" THEN
            LogWrite "File: " + Filename$, -1, %LogState_Normal
            Sort_NewsgroupList(Filename$)
        ELSE
            LogWrite "File: " + Filename$ + " (not a valid newsgroup file!)", -1, %LogState_FatalError
        END IF
END SUB

SUB Sort_NewsgroupList(Filename AS STRING)

        DIM NewsListMax   AS LONG
        DIM hGRFile       AS LONG

        NewsListMax = 50000
        DIM Newslist(NewsListMax) AS STRING

        hGRFile = FREEFILE
        OPEN Filename$ FOR INPUT AS #hGRFile

        i& = 0
        DO WHILE NOT EOF(hGRFile)
            i& = i& + 1
            LINE INPUT #hGRFile, Newslist$(i&)
            IF i& = NewslistMax THEN
                'LogWrite "", -1, %LogState_FatalError
                NewsListMax = NewsListMax + 50000
                REDIM PRESERVE Newslist$(NewslistMax)
            END IF
        LOOP
        CLOSE #hGRFile

        LogWrite "     " + STR$(i&-1) + " newsgroups", -1, %LogState_BriefMsg

        OPEN Filename$ FOR OUTPUT AS #hGRFile
        ARRAY SORT Newslist$(1) FOR i&, ASCEND
        FOR i& = 1 TO i&
           PRINT #hGRFile, Newslist$(i&)
        NEXT i&
        CLOSE #hGRFile

END SUB