'****************************************************************************
'
' UKAW Paket   : UKAWLOG.BAS (Common Logfile-Routines)
' Version      : 1.25g
' Compilation  : Thomas Gohel (gohel@basicguru.com)
' Last Files at: www.snafu.de/~pbsound/CrossPoint
'            or: www.basicguru.com/pbsound-hq/pbsources.win
' Last Updates : see directly in the sources
'
' all original sources by Karl-Heinz Weiss
'
'****************************************************************************

DECLARE FUNCTION LogDate AS STRING

%LogState_Normal      = 0
%LogState_FatalError  = 1
%LogState_OtherError  = 2
%LogState_CostInfo    = 3
%LogState_Filenames   = 4
%LogState_Routing     = 5
%LogState_BriefMsg    = 6
%LogState_TrivialMsg  = 7
%LogState_TransStat   = 8
%LogState_SessionInfo = 9
%LogState_RasDialResp = 10

SUB LogOpen()
        hLogFile = FREEFILE
        OPEN "UKAW.LOG" FOR APPEND AS #hLogFile
        PRINT #hLogFile, "----------  "+ LogDate$ + ", UKAW "; Version$;  " - (compilation by Thomas Gohel / 1999)"
END SUB

SUB LogWrite(Text$, LogThread&, LogState%)
        DIM sThread   AS STRING
        DIM sLogState AS STRING
        IF LogThread& >= 0 THEN
           sThread = "#" + FORMAT$(LogThread&,"#")
        ELSE
           sThread = "  "
        END IF

        SELECT CASE LogState%
            CASE  0: sLogState = "  "
            CASE  1: sLogState = "! "
            CASE  2: sLogState = "? "
            CASE  3: sLogState = "$ "
            CASE  4: sLogState = "* "
            CASE  5: sLogState = ": "      
            CASE  6: sLogState = "+ "
            CASE  7: sLogState = "- "
            CASE  8: sLogState = "% "
            CASE  9: sLogState = "~ "
            CASE 10: sLogState = "= "
        END SELECT

        STDOUT Text$
        PRINT #hLogFile, sLogState; TIME$; "  "; sLogApp$ ; sThread; ": "; Text$
END SUB

SUB LogClose
        CLOSE #hLogFile
END SUB

FUNCTION LogDate AS STRING

        LOCAL LogFormat AS STRING
        LOCAL SystemDatum AS SYSTEMTIME
        GetLocalTime SystemDatum

        SELECT CASE SystemDatum.wDayOfWeek
            CASE 0: LogDayOfWeek$ = "Sun"
            CASE 1: LogDayOfWeek$ = "Mon"
            CASE 2: LogDayOfWeek$ = "Tue"
            CASE 3: LogDayOfWeek$ = "Wed"
            CASE 4: LogDayOfWeek$ = "Thu"
            CASE 5: LogDayOfWeek$ = "Fri"
            CASE 6: LogDayOfWeek$ = "Sat"
        END SELECT

        LogDay$ = FORMAT$(SystemDatum.wDay,"##")
        REPLACE " " WITH "0" IN LogDay$

        LogXPMonth$ = FORMAT$(SystemDatum.wMonth,"##")
        REPLACE " " WITH "0" IN LogXPMonth$

        LogFormat$ = UCASE$(ENVIRON$("UKAWLOG"))

        SELECT CASE SystemDatum.wMonth
            CASE  1: LogFDMonth$ = "Jan"
            CASE  2: LogFDMonth$ = "Feb"
            CASE  3: LogFDMonth$ = "Mar"
            CASE  4: LogFDMonth$ = "Apr"
            CASE  5: LogFDMonth$ = "May"
            CASE  6: LogFDMonth$ = "Jun"
            CASE  7: LogFDMonth$ = "Jul"
            CASE  8: LogFDMonth$ = "Aug"
            CASE  9: LogFDMonth$ = "Sep"
            CASE 10: LogFDMonth$ = "Oct"
            CASE 11: LogFDMonth$ = "Nov"
            CASE 12: LogFDMonth$ = "Dec"
        END SELECT

        LogYear$ = STR$(SystemDatum.wYear)

        SELECT CASE LogFormat$
            CASE "XP"
                FUNCTION = LogDay$ + "." + LogXPMonth$ + "." + _
                           RIGHT$(LogYear$,4)
            CASE "FD"
                FUNCTION = LogDayOfWeek$ + " "  + LogDay$ + " " + _
                           LogFDMonth$ + " " + RIGHT$(LogYear$,2)
            CASE ELSE
                FUNCTION = LogDayOfWeek$ + " "  + LogDay$ + " " + _
                           LogFDMonth$ + " " + RIGHT$(LogYear$,2)
        END SELECT

END FUNCTION