'****************************************************************************
'
' UKAW Paket   : WDIAL
' Version      : 1.33g
' Compilation  : Thomas Gohel (gohel@basicguru.com)
' Last Files at: www.snafu.de/~pbsound/CrossPoint
'            or: www.basicguru.com/pbsound-hq/pbsources.win
' Last Updates : see directly in the sources
'
' all original sources by Karl-Heinz Weiss
'
'****************************************************************************

$RESOURCE "UKAW.PBR"
$INCLUDE  "WIN32API.INC"
$INCLUDE  "RAS.INC"
$INCLUDE  "UKAW.INC"
$INCLUDE  "UKAWLOG.BAS"

DECLARE SUB Sleep LIB "KERNEL32.DLL" ALIAS "Sleep" (BYVAL dwMilliseconds AS LONG)
DECLARE FUNCTION SetConsoleTitle LIB "KERNEL32.DLL" ALIAS "SetConsoleTitleA" (lpConsoleTitle AS ASCIIZ) AS LONG
DECLARE SUB MakeSemaphore (Filename AS STRING)
GLOBAL rdparam AS rasdialparams
GLOBAL PerformPass AS INTEGER
DEFLNG a-z

SUB hup(tthup)
    DIM rasconnentries(0) AS rasconn
    DIM stitle AS ASCIIZ*40
    rasconnentries(0).dwsize=SIZEOF(rasconnentries(0))
    bufsize=SIZEOF(rasconnentries(0))
    bufnbr=0
    result=RasEnumConnections(VARPTR(rasconnentries(0)),bufsize,bufnbr)
    bufnbr=1
    IF bufnbr<1 THEN
        LogWrite "No active connection.", -1, %LogState_RasDialResp
    ELSE
        t0=TIMER
        DO WHILE dt<tthup
            sleep 500
            t=TIMER
            IF t<t0 THEN t=t+86400
            dt=t-t0
            stitle="Hangup (Sec):"+STR$(tthup-dt)
            setconsoletitle stitle
        LOOP
        FOR i=1 TO bufnbr
            a$ = rasconnentries(i-1).szEntryname
            IF rashangup(rasconnentries(i-1).hrasconn)=0 THEN
                LogWrite a$ + " disconnected.", -1, %LogState_RasDialResp
            ELSE
                LogWrite a$ + " NOT disconnected!", -1, %LogState_RasDialResp
            END IF
        NEXT
    END IF
END SUB

FUNCTION dialup(dummy&)
   lphras=0
   FUNCTION= rasdial (0,0,rdParam,0,0,lphras)
END FUNCTION

FUNCTION dial(ISP$, cmd$,retries,tout)

        DIM hras AS rasconn PTR
        DIM rasconnentries(0) AS rasconn

        rasconnentries(0).dwsize = SIZEOF(rasconnentries(0))
        bufsize = SIZEOF(rasconnentries(0))
        bufnbr = 0
        fBool = 0
        result = RasEnumConnections(VARPTR(rasconnentries(0)), bufsize, bufnbr)

        IF bufnbr <> 0 THEN
            LogWrite "A connection to '" + rasconnentries(0).szEntryname + "' exists already!", -1, %LogState_RasDialResp
            MakeSemaphore("WDial.Already")
            FUNCTION = 1
        ELSE
            rdparam.dwsize = SIZEOF(rdparam)
            rdparam.szentryname = ISP$
            result = RasGetEntryDialParams(0, rdparam, fBool)
            IF result <> 0 THEN
                LogWrite "'" + rdparam.szentryname + "' doesn't exist!", -1, %LogState_OtherError
                FUNCTION = 3
                EXIT FUNCTION
            END IF
            IF PARSE$(cmd$," ",2)> "" THEN
                rdparam.szusername = PARSE$(cmd$, " ", 2)
            ELSE
                IF rdparam.szusername = "" THEN
                    STDOUT "Username: ";
                    STDIN LINE rdparam.szusername
                END IF
            END IF
            IF PARSE$(cmd$," ",3) > "" THEN
                rdparam.szpassword = PARSE$(cmd$, " ", 3)
            ELSE
                IF rdparam.szpassword = "" OR PerformPass% <> 0 THEN
                    STDOUT"Password: ";
                    STDIN LINE rdparam.szpassword
                END IF    
            END IF
            IF PARSE$(cmd$," ",4)>"" THEN
                 rdparam.szphonenumber = PARSE$(cmd$, " ", 4)
            END IF
            DO
                THREAD CREATE dialup(dummy&) TO dhdl&
                DO
                    THREAD STATUS dhdl& TO result
                    Sleep 1
                    a$ = INKEY$
                LOOP WHILE result = &h103 AND a$<>CHR$(27)

                'Benutzer-Abbruch behandeln. Notwendig weil RasEnumConnections unter NT nur
                'bei erfolgreichem Verbindungsaufbau einen Connection-Handle liefert.
                IF a$ = CHR$(27) THEN
                    STDOUT "Please Wait ..."
                    DO
                        Sleep 1
                        THREAD STATUS dhdl& TO result
                        rs = RasEnumConnections(VARPTR(rasconnentries(0)),bufsize,bufnbr)
                    LOOP WHILE result = &h103 AND bufnbr = 0
                    result=631
                END IF
                THREAD CLOSE dhdl& TO dummy
                IF a$ = CHR$(27) THEN
                    EXIT DO
                END IF    
                DECR retries
                IF (result = 676 AND retries > 0) THEN
                    hup 0
                    LogWrite "Busy, Retrying in" + STR$(tout) + " seconds...", -1, %LogState_Normal
                    FOR i = 1 TO tout
                        Sleep 1000
                        IF INKEY$ = CHR$(27) THEN
                            retries = 0
                            result = &h103
                            EXIT DO
                        END IF    
                    NEXT
                END IF
            LOOP WHILE retries > 0 AND result = 676
            IF result <>0 THEN
                hup 0
                MakeSemaphore("WDial.No")
                LogWrite "Dial failed!", -1, %LogState_FatalError
                LogWrite "Reason: " + GetRasError(Result), -1, %LogState_SessionInfo
                FUNCTION = 2
            ELSE
                FUNCTION = 0
                LogWrite "Connected to "+rdparam.szentryname, -1, %LogState_RasDialResp
            END IF
        END IF
END FUNCTION

SUB MakeSemaphore(Filename AS STRING)
    iSemaHandle = FREEFILE
    OPEN Filename$ FOR BINARY AS iSemaHandle
    CLOSE iSemaHandle
END SUB

SUB DelSemaphore(Filename AS STRING)
    IF LEN(Dir$(Filename$)) > 0 THEN
        KILL Filename$
    END IF
END SUB

SUB DelAllSemaphore
    DelSemaphore("WDial.Already")
    DelSemaphore("WDial.No")
END SUB

FUNCTION PBMAIN
    $INCLUDE "UKAW.VER"
    sLogApp = "WDIAL  "

    IF COMMAND$="" OR INSTR(COMMAND$,"?")>0 THEN
        STDOUT "WDIAL " + Version$ + "                            (Freeware sources by Karl-Heinz Weiss)"
        STDOUT "                                                   compilation by " + Author$
        STDOUT " "
        STDOUT "Usage: wdial <name_of_connection>[ <user>[ <pass>[ <phonenumber>]]][,Options]"
        STDOUT "       wdial <" + CHR$(34) + "long name of ISP" + CHR$(34) + ">[ <user>[ <pass>[ <phonenumber>]]][,Options]"
        STDOUT "or   : wdial -h (performs a hangup)"
        STDOUT "     : wdial -s (performs a hangup, after the state of the connection)"
        STDOUT "     : start /m wdial -h nn (performs hangup after nn seconds)"
        STDOUT "Options: -r n  Number of redial attempts if busy"
        STDOUT "         -t n  Redial timeout (default: 5 sec)"
        STDOUT "         -p    performs password entry, use it for temporally passwords"
        EXIT FUNCTION
    END IF
    LogOpen
  
    cmd$=TRIM$(COMMAND$)
    IF INSTR(cmd$,"-h")=1 THEN
       tthup=VAL(MID$(cmd$,3))
       hup tthup
       LogClose
       DelAllSemaphore
       EXIT FUNCTION
    END IF
    IF INSTR(cmd$,"-s")=1 THEN
       IF LEN(DIR$("WDial.Already")) = 0 THEN
           tthup=VAL(MID$(cmd$,3))
           hup tthup
           LogClose
           DelAllSemaphore
           EXIT FUNCTION
        ELSE
           LogWrite "Connection was already in use, not disconnected ...", -1, %LogState_RasDialResp
           LogClose
           EXIT FUNCTION
        END IF
    END IF
    DelAllSemaphore
    p=INSTR(Cmd$,",")
    IF p THEN
       opt$=MID$(cmd$,p+1)
       cmd$=LEFT$(cmd$,p-1)
       p=INSTR(opt$,"-r")
       IF p THEN
          retries=VAL(MID$(opt$,p+2))
       END IF
       p=INSTR(opt$,"-t")
       IF p THEN tout=VAL(MID$(opt$,p+2))
       p = INSTR(opt$,"-p")
       IF p > 0 THEN
           PerformPass% = 1
       END IF
    END IF
    IF tout=0 THEN tout=5

    '/// v1.21g Handling fuer lange ISP-Names ///
    ifLongName% = INSTR(1, cmd$, CHR$(34))
    IF iflongName% > 0 THEN
        iflongNameEnd% = INSTR(ifLongName% + 1, cmd$, CHR$(34))
        ISP$ = MID$(cmd$, ifLongName% + 1,  ifLongNameEnd%-ifLongName%-1)
        cmd$ = "Dummy" + MID$(cmd$, iflongNameEnd% + 1, 255)
    ELSE
        ISP$ = PARSE$(cmd$," ",1)
    END IF

    FUNCTION=dial(ISP$, cmd$,retries,tout)
    'PRINT ">";cmd$; "<",retries,tout
    'PRINT ">"; isp$; "<"

    ' /// v1.21g Handling fuer lange ISP Names
    LogClose

END FUNCTION
